<template>
  <ob-form
      :form-data="formData"
      :form-model="formModel"
      :is-loading="isShowLoader"
      @submit="onSubmitHandler"
      :okText="isNew ? 'Добавить' : 'Сохранить'"
      data-qa="formPointsGroupBP"
      :dropdown-menu="dropdownMenu"
  >
    <div class="row">
      <div class="col-xs-12">
        <div class="form-group">
          <ob-input
            label="Наименование"
            v-model="formData.title"
            placeholder="Укажите наименование"
            :required="true"
            @input="resetError"
            data-qa="inputPointTitleBP"
          />
        </div>
      </div>
      <div class="col-xs-12">
        <div class="form-group">
          <ObSelect
              v-model="formData.referencePositions"
              label="Опорники"
              :isTagbox="true"
              :isDropdown="true"
              :required="true"
              :withCheckbox="true"
              placeholder="Выберите один или несколько опорников"
              displayExp="russian_name"
              :items="locationsList"
              :is-auto-complete="true"
              @input="resetError"
              data-qa="selectMultipleLocationPointsBP"
          />
        </div>
      </div>
    </div>

    <transition name="fadeIn">
      <ObAlert
          v-if="error"
          :text="error"
          class="alert-error"
          theme="danger"
          icon="alert"
          :hide-close-button="true"
      />
    </transition>

  </ob-form>
</template>

<script>
import api from '@/api';
import FormValidationMixin from "common-components/src/obComponents/obForm/FormValidationMixin";
import ObForm from "common-components/src/obComponents/obForm";
import ObInput from "common-components/src/obComponents/obInput";
import ObAlert from "common-components/src/obComponents/obAlert";
import ObSelect from "common-components/src/obComponents/obSelect";
import dropdownEvents from "@/mixins/dictionaries/dropdown-events";
import { required } from "vuelidate/lib/validators";

export default {
  name: "BasePricePointsGroupForm",
  components: {
    ObForm,
    ObInput,
    ObAlert,
    ObSelect,
  },
  mixins: [FormValidationMixin, dropdownEvents],
  props: { },
  data () {
    return {
      error: '',
      isShowLoader: false,
      locationsList: [],
    }
  },
  computed: {
    isNew () {
      return !this.formData.groupUuid
    },
    formModel() {
      return {
        groupUuid: {
          value: ''
        },
        title: {
          value: '',
          validator: {
            required
          }
        },
        referencePositions: {
          value: null,
          validator: {
            required
          }
        },
      }
    },
    dropdownMenu () {
      return [
        {
          title: 'Удалить',
          className: 'menu-button-danger',
          isHidden: this.isNew,
          method: this.deleteGroup
        }
      ]
    },
  },
  methods: {
    async onSubmitHandler() {
      let params = {...this.formData};
      this.isShowLoader = true;
      try {
        if(!params.groupUuid) {

          await api.base_prices_intracity.createIntracityGroup(params)
            .then((res) => {
              this.$notification({
                type: "system_notification_success",
                message: "Группа успешно создана",
              });
              this.$emit("save", {formData: res});
            })
            .finally(() => {
              this.isShowLoader = false;
            });

        } else {

          await api.base_prices_intracity.updateIntracityGroup(params.groupUuid, params)
            .then((res) => {
              this.$notification({
                type: "system_notification_success",
                message: "Группа успешно обновлена",
              });
              this.$emit("save", {formData: res});
            })
            .finally(() => {
              this.isShowLoader = false;
            });

        }

      } catch (err) {
        this.isShowLoader = false;
        this.$notification({type: 'system_notification_error', message: 'Ошибка сохранения группы'});
        if (err.error) {
          this.error = err?.error_message ? err?.error_message : err.error;
        }
      }
    },
    async getLocations({ query = '', page = 0, size = 10000, filters }) {
      try {
        const data = await api.locations.getLocations(page, size, query, [], filters);
        this.locationsList = data.data.content;
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        })
        this.locationsList = [];
      }
    },
    deleteGroup() {
      this.$emit('delete')
    },
    resetError() {
      this.error = '';
    },
    close() {
      this.$emit('close')
    },
  },
  mounted() {
    let locationsParams = {
      query: '',
      page: 0,
      size: 10000,
      filters: {
        location_type_uuid: '5919a99f-d840-4855-b158-5ba957076603', // только опорники
      }
    }
    this.getLocations(locationsParams);
  },
};
</script>

<style lang="scss">
@import "~common-components/src/static/css/mixins";
.form-group {
  justify-content: space-between;
  align-self: flex-start;
  margin-bottom: 20px;

  &__title {
    @include font-mixin(20px, 28px, 700, #191E32, 0.4px);
    margin-bottom: 10px;
  }

  &__label {
    @include font-mixin(14px, 18px, 400, #737682, 0.2px);
    margin-bottom: 15px;
  }

  .input-group .input{
    color: $cobalt-black;
  }
}
</style>